var types = [];

module.exports = function extend(auto, manual) {
  var merged = {};
  manual = manual || {};
  var key;
  for (key in auto) {
    merged[key] = auto[key];
  }
  for (key in manual) {
    merged[key] = manual[key];
  }

  types.forEach(function(extendType) {
    merged = extendType(merged, auto, manual) || merged;
  });

  return merged;
};

types.push(
// external_component
function (merged, auto, manual) {
      var key;
      for (key in merged.EXTERNAL_COMPONENTS) {
        var value = merged.EXTERNAL_COMPONENTS[key];
        var subkey;
        for (subkey in value.package) {
          if (!merged[subkey]) {
            merged[subkey] = value.package[subkey];
          }
        }
        if (!merged[key]) {
          merged[key] = value.component;
        }
      }
      delete merged.EXTERNAL_COMPONENTS;
    }
);

types.push(
// component
function () {}
);

types.push(
// model
function () {}
);

types.push(
// template
function (merged, auto, manual) {
      if (manual.TEMPLATES) {
        var MERGED_TEMPLATES = merged.TEMPLATES = {};
        var AUTO_TEMPLATES = auto.TEMPLATES;
        var TEMPLATES = manual.TEMPLATES;
        var key;
        for (key in AUTO_TEMPLATES) {
          MERGED_TEMPLATES[key] = AUTO_TEMPLATES[key];
        }
        for (key in TEMPLATES) {
          MERGED_TEMPLATES[key] = TEMPLATES[key];
        }
      }
    }
);

types.push(
// initializer
function (merged, auto, manual) {
      if (manual.INITIALIZERS) {
        var MERGED_INITIALIZERS = merged.INITIALIZERS = {};
        var AUTO_INITIALIZERS = auto.INITIALIZERS;
        var INITIALIZERS = manual.INITIALIZERS;
        var key;
        for (key in AUTO_INITIALIZERS) {
          MERGED_INITIALIZERS[key] = AUTO_INITIALIZERS[key];
        }
        for (key in INITIALIZERS) {
          MERGED_INITIALIZERS[key] = INITIALIZERS[key];
        }
      }
    }
);

types.push(
// router
function (merged, auto, manual) {
      if (manual.ROUTERS) {
        var MERGED_ROUTERS = [];
        var AUTO_ROUTERS = auto.ROUTERS || [];
        var ROUTERS = manual.ROUTERS;
        var key;
        MERGED_ROUTERS = MERGED_ROUTERS
          .concat(AUTO_ROUTERS, ROUTERS)
          .filter(function(router, index, array) {
            return !array.slice(0, index).reduce(function(carry, _router) {
              return carry || _router === router;
            }, false);
          });
        merged.ROUTERS = MERGED_ROUTERS;
      }
      // TODO 0.1: Remove ROUTING member.
      if (manual.ROUTING) {
        module.ROUTING = manual.ROUTING;
      }
    }
);

types.push(
// controller
function () {}
);

types.push(
// route
function () {}
);

types.push(
// view
function () {}
);

types.push(
// style
function (merged, auto, manual) {
      if (manual.STYLES) {
        var MERGED_STYLES = merged.STYLES = {};
        var AUTO_STYLES = auto.STYLES;
        var STYLES = manual.STYLES;
        var key;
        for (key in AUTO_STYLES) {
          MERGED_STYLES[key] = AUTO_STYLES[key];
        }
        for (key in STYLES) {
          MERGED_STYLES[key] = STYLES[key];
        }
      }
    }
);

types.push(
// css
function () {}
);

types.push(
// less
function () {}
);

types.push(
// sass
function () {}
);

types.push(
// stylus
function () {}
);